<template>
  <div>
    <meta name="viewport" content="width=device-width,initial scale=" />
    <link rel="stylesheet" href="https://www.w3schools.com/lib/w3.css" />
    <div class="user_name" @click="ToggleTable()">
      {{ userDetails.Name }}
      <v-btn
        color="black"
        depressed
        class="delete-btn"
        :disabled="wholearray[0] === 'Paid' || dinamic_Pay ? false : true"
        @click.stop="DeliveryShipping(tableHeder)"
        >Delivery
      </v-btn>
      <v-btn
        color="black"
        depressed
        class="delete-btn"
        :disabled="
          this.wholearray[1] === 'confirmed' || dinamic_Book ? false : true
        "
        @click.stop="updatedb(tableHeder)"
        >Paid
      </v-btn>
      <v-btn
        color="black"
        depressed
        class="delete-btn"
        @click.stop="Booked(tableHeder)"
        >Book
      </v-btn>

      <v-btn
        color="black"
        depressed
        class="delete-btn"
        @click.stop="deleteuserorder(tableHeder)"
      >
        <v-icon left>
          {{ icons.mdiDelete }}
        </v-icon>
        Delete
      </v-btn>
      <h5 class="finalPrice">Price: ₹{{ finalPrice }}</h5>
    </div>

    <div v-if="Table" class="table">
      <p class="idCenter">
        Customer OrderId: <strong class="idsize">{{ tableHeder }}</strong>
      </p>
      <table class="userTable">
        <tr class="Userinfo">
          <th>Customer Name</th>
          <th>Email</th>
          <th>Contact Number</th>
          <th>Address</th>
        </tr>
        <tr>
          <td>{{ userDetails.Name }}</td>
          <td>{{ userDetails.email }}</td>
          <td>{{ userDetails.Mobile }}</td>
          <td>
            {{ userDetails.Address }}, {{ userDetails.City }},{{
              userDetails.Zipcode
            }}
          </td>
        </tr>
      </table>

      <table>
        <tr class="userProinfoTable">
          <th>Product Name</th>
          <th>Serial Number</th>
          <th>Quanity</th>
          <th>Price</th>
        </tr>
        <tr v-for="(crakers, i) in firstone" :key="i">
          <td>{{ crakers.ProductName }}</td>
          <td>{{ crakers.SerialNo }}</td>
          <td>{{ crakers.Quanity }}</td>
          <td>₹{{ crakers.TotalPrice }}</td>
          <td>{{ crakers.paid }}</td>
        </tr>
        <tr>
          <td>
            Delivery:
            <strong
              >{{ dinamic_Delivery ? "delivered" : this.wholearray[2] }}
            </strong>
          </td>
          <td>
            Book:
            <strong>{{
              dinamic_Book ? "confirmed" : this.wholearray[1]
            }}</strong>
          </td>
          <td>
            Payment:
            <strong>{{ dinamic_Pay ? "paid" : this.wholearray[0] }}</strong>
          </td>

          <td class="totalprice">Total: ₹{{ finalPrice }}</td>
        </tr>
      </table>
    </div>
  </div>
</template>
<script>
import { db } from "../firebase/db";
// import firebase from "firebase";
import { mdiDelete } from "@mdi/js";

export default {
  props: ["tableHeder", "tabelContent", "index"],
  data: () => ({
    headers: [
      {
        text: "Product Name",
        align: "start",
        value: "name",
      },
      { text: "Serial No", value: "Serial" },
      { text: "Price", value: "Price" },
      { text: "Qty", value: "qty" },
    ],
    icons: {
      mdiDelete,
    },
    finalPrice: null,
    firstone: null,
    userDetails: null,
    Table: false,
    Pay: [],
    payment: null,
    dinamic_Pay: false,
    dinamic_Book: false,
    dinamic_Delivery: false,
    NOTable: true,
    Booking: [],
    Delivery: [],
    wholearray: [],
    bkbtn: false,
    paidbtn: false,
    deliverybtn: false,
  }),

  computed: {},

  methods: {
    ToggleTable() {
      this.Table = !this.Table;
    },
    totalPrice() {
      var sum = 0;
      var id = this.firstone;
      for (var is = 0; is < id.length; is++) {
        if (isFinite(id[is].TotalPrice)) {
          sum += +id[is].TotalPrice;
        }
      }
      this.finalPrice = sum;
      // console.log(this.finalPrice);
    },
    deleteuserorder(id) {
      this.$emit("onDelete", this.index);

      db.collection("crackers")
        .doc(id)
        .delete()
        .then(() => {
          this.$toast.info(
            this.userDetails.Name + "Order successfully deleted!",
            {
              duration: "3000",
            }
          );
        })
        .catch(() => {
          this.$toast.error("Error removing Order Please Contact Mithun", {
            duration: "3000",
          });
        });

      db.collection("payment")
        .doc(id)
        .delete()
        .then(() => {})
        .catch(() => {
          this.$toast.error(
            this.userDetails.Name +
              "Error removing Order Please Contact Mithun",
            {
              duration: "3000",
            }
          );
        });
      db.collection("Booking")
        .doc(id)
        .delete()
        .then(() => {})
        .catch(() => {
          this.$toast.error(
            this.userDetails.Name +
              "Error removing Order Please Contact Mithun",
            {
              duration: "3000",
            }
          );
        });
      db.collection("Delivery")
        .doc(id)
        .delete()
        .then(() => {})
        .catch(() => {
          this.$toast.error(
            this.userDetails.Name +
              "Error removing Order Please Contact Mithun",
            {
              duration: "3000",
            }
          );
        });
    },
    updatedb(id) {
      this.dinamic_Pay = true;
      // debugger; // eslint-disable-line no-debugger
      db.collection("payment")
        .doc(id)
        .update({
          paid: "Paid",
        })
        .then(() => {
          console.log("Document successfully deleted!");
        })
        .catch((error) => {
          console.error("Error removing document: ", error);
        });
    },
    Booked(id) {
      this.dinamic_Book = true;
      db.collection("Booking")
        .doc(id)
        .update({
          book: "confirmed",
        })
        .then(() => {
          console.log("Document successfully deleted!");
        })
        .catch((error) => {
          console.error("Error removing document: ", error);
        });
    },
    DeliveryShipping(id) {
      // debugger; // eslint-disable-line no-debugger
      this.dinamic_Delivery = true;
      db.collection("Delivery")
        .doc(id)
        .update({
          delivery: "delivered",
        })
        .then(() => {
          console.log("Document successfully deleted!");
        })
        .catch((error) => {
          console.error("Error removing document: ", error);
        });
    },
    joinarray() {
      // debugger; // eslint-disable-line no-debugger
      for (var i in this.Pay) {
        if (this.tableHeder === this.Pay[i].id) {
          this.wholearray.push(this.Pay[i].paid);
          break;
        }
      }
      for (var is in this.Booking) {
        if (this.tableHeder === this.Booking[is].id) {
          this.wholearray.push(this.Booking[is].book);
          break;
        }
      }
      for (var iss in this.Delivery) {
        if (this.tableHeder === this.Delivery[iss].id) {
          this.wholearray.push(this.Delivery[iss].delivery);
          break;
        }
      }
    },
  },
  mounted() {
    this.userDetails = this.tabelContent[0];
    this.firstone = this.tabelContent.slice(1);

    this.totalPrice();
    this.$store.state.orderData = this.tabelContent;
    db.collection("payment").onSnapshot((querySnapshot) => {
      querySnapshot.forEach((doc) => {
        const doc2 = doc.data();
        doc2.id = doc.id;
        this.Pay.push(doc2);
        // console.log(this.Pay);
      });
    });
    db.collection("Booking").onSnapshot((querySnapshot) => {
      querySnapshot.forEach((doc) => {
        const doc2 = doc.data();
        doc2.id = doc.id;
        this.Booking.push(doc2);
        // console.log(this.Pay);
      });
    });
    db.collection("Delivery").onSnapshot((querySnapshot) => {
      querySnapshot.forEach((doc) => {
        const doc2 = doc.data();
        doc2.id = doc.id;
        this.Delivery.push(doc2);
        // console.log(this.Pay);
      });
    });
    setTimeout(() => {
      this.joinarray();
    }, 500);

    console.log(this.wholearray);
  },
};
</script>
<style scoped>
.idsize {
  font-size: 25px;
}
.idCenter {
  text-align: center;
}
.user_name {
  /* height: 50px; */
  width: 1100px;
  /* display: flex; */
  text-transform: capitalize;
  background-color: #4e0321;
  color: #fff;
  font-size: 18px;
  padding: 1rem 2rem;
  margin: 5px auto;
  border-radius: 5px;
}
.finalPrice {
  display: inline-flex;
  width: 150px;
  text-align: center;
  float: right;
}
table {
  width: 1100px;
  margin: auto;
}
.Userinfo th,
td,
.userProinfoTable th {
  width: 25%;
  text-align: center;
}
/* .userProinfoTable th{
    width: 25%;
    text-align: center;
} */
.Userinfo th,
.userProinfoTable th {
  background-color: #ad5c7d;
  color: #fff;
}
.delete-btn {
  float: right;
  margin: 2px;
}
.totalprice {
  font-size: 20px;
  font-weight: 800;
}
</style>
